﻿// Add any initialization logic to this function.
Office.initialize = function (reason) {

    // Checks for the DOM to load.
    $(document).ready(function () {
        $("#bt_useSelectedText").click(function () { getData("query"); });

        // Attaches a click handler to the button.
        $('#bt_search').click(function (e) {

            // Clear the results div.
            $('#results').empty();
            var query = $('#query').val();
            var serviceOp = $('input[name=service_op]:checked', '#my_form').val();
            if (query)
                search(query, serviceOp);
        });
    })
}

// Reads data from current selection.
function getData(elementIdToUpdate) {
    Office.context.document.getSelectedDataAsync(Office.CoercionType.Text,
    function (result) {
        if (result.status == "succeeded") {
            document.getElementById(elementIdToUpdate).value = result.value;
        }
    });
}

// Performs the search.
function search(query, serviceOp) {
    // Establish the data to pass to the proxy.
    var data = { q: query, sop: serviceOp, market: 'en-us' };

    // Calls the proxy, passing the query, service operation and market.
    /*$.getJSON('http://officedeveloper.net/apps/BingSample/bing_proxy.php', data, function (obj) {
        if (obj.d !== undefined) {
            var items = obj.d.results;
            for (var k = 0, len = items.length; k < len; k++) {
                var item = items[k];
                switch (item.__metadata.type) {
                    case 'WebResult':
                        showWebResult(item);
                        break;
                    case 'ImageResult':
                        showImageResult(item);
                        break;
                }
            }
        }
    });*/

    // XMLHttpRequest cannot load bing_proxy.php. Cross domain requests are not allowed.
    // So, we're using the GET request to load the proxy by passing "script" to dataType.
    request = $.ajax({
        url: 'http://officedeveloper.net/apps/BingSample/new/bing_proxy.php',
        type: "GET",
        dataType: "script",
        data: data
    }).done(requestDone);

}

function requestDone(result) {
    return false;
}

// This function is called in bing_proxy.php
function successSearchCallback(obj) {
    if (obj.d !== undefined) {
        var items = obj.d.results;
        for (var k = 0, len = items.length; k < len; k++) {
            var item = items[k];
            switch (item.__metadata.type) {
                case 'WebResult':
                    showWebResult(item);
                    break;
                case 'ImageResult':
                    showImageResult(item);
                    break;
            }
        }
    }
}

// Shows one item of Web result.
function showWebResult(item) {
    var p = document.createElement('p');
    var a = document.createElement('a');
    a.href = item.Url;
    $(a).append(item.Title);
    $(p).append(item.Description);
    // Append the anchor tag and paragraph with the description to the results div.
    $('#results').append(a, p);
}

// Shows one item of Image result.
function showImageResult(item) {
    var p = document.createElement('p');
    var a = document.createElement('a');
    a.href = item.MediaUrl;
    // Create an image element and set its source to the thumbnail.
    var i = document.createElement('img');
    i.src = item.Thumbnail.MediaUrl;
    // Make the object that the user clicks the thumbnail image.
    $(a).append(i);
    $(p).append(item.Title);
    // Append the anchor tag and paragraph with the title to the results div.
    $('#results').append(a, p);
}

